package binarization;

import java.util.Scanner;

/**
 * Carregador de instancias da classe {@code T}. Para carregar, utiliza os parametros
 * do {@link Scanner} para chamar o construtor apropriado.
 * 
 * @author denis
 * @param <T> a classe a ser carregada
 * @see LoadManager
 * @see IBinarizationMethod
 * @see IBinaryImageMetric
 */
public interface ILoader<T> {

	/**
	 * Carrega uma instancia da classe {@code T} dado os parametros obtidos
	 * atraves do {@link Scanner} dado. O {@code Scanner} deve estar na
	 * posicao do primeiro parametro.
	 * 
	 * @param parameters um {@link Scanner} que possui os parametros de construcao
	 * @return uma instancia da classe {@code T}
	 */
	T load(Scanner parameters);
}
