package binarization.data;

public class ImagePoint {

	private final int x;
	private final int y;

	private ImagePoint(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public static ImagePoint of(int x, int y) {
		return new ImagePoint(x, y);
	}

	public int x() {
		return x;
	}

	public int y() {
		return y;
	}

	public ImagePoint above() {
		return of(x, y - 1);
	}

	public ImagePoint below() {
		return of(x, y + 1);
	}

	public ImagePoint left() {
		return of(x - 1, y);
	}

	public ImagePoint right() {
		return of(x + 1, y);
	}

	public boolean isInside(ImageSize size) {
		return (0 <= x && x < size.width() && 0 <= y && y < size.height());
	}

	public boolean isInImage(IImage image) {
		return isInside(image.size());
	}
}
