package binarization.methods.loaders;

import binarization.IBinarizationMethod;
import binarization.ILoader;
import binarization.methods.FileMethod;
import java.util.Scanner;

/**
 * Classe auxiliar usada para instanciacao por reflexao.
 */
public class FileMethodLoader implements ILoader<IBinarizationMethod> {

	/**
	 * Construtor que facilita a instanciacao por reflexao.
	 */
	public FileMethodLoader() {
	}

	@Override
	public IBinarizationMethod load(Scanner parameters) {
		if (!parameters.hasNext()) {
			throw new IllegalArgumentException("Method needs a text file with images.");
		}

		return new FileMethod(parameters.next());
	}

}
