package binarization.methods.loaders;

import binarization.ILoader;
import binarization.IBinarizationMethod;
import binarization.methods.NiblackMethod;
import java.util.Scanner;

/**
 * Classe auxiliar usada para instanciacao por reflexao.
 */
public class NiblackMethodLoader implements ILoader<IBinarizationMethod> {

	/**
	 * Construtor que facilita a instanciacao por reflexao.
	 */
	public NiblackMethodLoader() {
	}

	@Override
	public IBinarizationMethod load(Scanner parameters) {

		if (!parameters.hasNextInt()) {
			throw new IllegalArgumentException("This method needs at least one parameter.");
		}

		final int windowSize = parameters.nextInt();

		if (!parameters.hasNextDouble()) {
			return new NiblackMethod(windowSize);
		}

		final double weight = parameters.nextDouble();

		return new NiblackMethod(windowSize, weight);
	}
}