package binarization.methods.loaders;

import binarization.ILoader;
import binarization.IBinarizationMethod;
import binarization.methods.SauvolaMethod;
import java.util.Scanner;

/**
 * Classe auxiliar usada para instanciacao por reflexao.
 */
public class SauvolaMethodLoader implements ILoader<IBinarizationMethod> {

	/**
	 * Construtor que facilita a instanciacao por reflexao.
	 */
	public SauvolaMethodLoader() {
	}

	@Override
	public IBinarizationMethod load(Scanner parameters) {

		if (!parameters.hasNextInt()) {
			throw new IllegalArgumentException("This method needs at least one parameter.");
		}

		final int windowSize = parameters.nextInt();

		if (!parameters.hasNextDouble()) {
			return new SauvolaMethod(windowSize);
		}

		final double weight = parameters.nextDouble();

		if (!parameters.hasNextDouble()) {
			return new SauvolaMethod(windowSize, weight);
		}

		final double range = parameters.nextDouble();

		return new SauvolaMethod(windowSize, weight, range);
	}
}