package binarization.methods.loaders;

import binarization.ILoader;
import binarization.IBinarizationMethod;
import binarization.methods.SuMethod;
import java.util.Scanner;

/**
 * Classe auxiliar usada para instanciacao por reflexao.
 */
public class SuMethodLoader implements ILoader<IBinarizationMethod> {

	/**
	 * Construtor que facilita a instanciacao por reflexao.
	 */
	public SuMethodLoader() {
	}

	@Override
	public IBinarizationMethod load(Scanner parameters) {
		if (!parameters.hasNextInt()) {
			throw new IllegalArgumentException("This method needs at least two parameters.");
		}

		final int windowSize = parameters.nextInt();

		if (!parameters.hasNextInt()) {
			throw new IllegalArgumentException("This method needs at least two parameters.");
		}

		final int minHighContrastPixels = parameters.nextInt();

		if (!parameters.hasNextInt()) {
			return new SuMethod(windowSize, minHighContrastPixels);
		}

		final int constrastWindowSize = parameters.nextInt();

		return new SuMethod(windowSize, minHighContrastPixels, constrastWindowSize);
	}
}