package binarization.metrics.loaders;

import binarization.IBinaryImageMetric;
import binarization.ILoader;
import binarization.metrics.DistanceReciprocalDistortionMetric;
import java.util.Scanner;

/**
 * Classe auxiliar usada para instanciacao por reflexao.
 */
public class DistanceReciprocalDistortionMetricLoader implements ILoader<IBinaryImageMetric> {

	/**
	 * Construtor que facilita a instanciacao por reflexao.
	 */
	public DistanceReciprocalDistortionMetricLoader() {
	}

	@Override
	public IBinaryImageMetric load(Scanner parameters) {
		if (!parameters.hasNextInt()) {
			return DistanceReciprocalDistortionMetric.DEFAULT;
		}

		final int weightedMatrixDimension = parameters.nextInt();

		if (!parameters.hasNextInt()) {
			return DistanceReciprocalDistortionMetric.DEFAULT;
		}

		final int nonUniformBlockSize = parameters.nextInt();

		return new DistanceReciprocalDistortionMetric(weightedMatrixDimension, nonUniformBlockSize);
	}
}