package binarization.util;

import java.util.Comparator;

/**
 * Classe utilitaria que implementa a interface {@link Comparator} para
 * {@code Double} em ordem crescente (padrao) como em ordem decrescente.
 *
 * @author denis
 */
public enum Comparators implements Comparator<Double> {

	/**Ordem crescente, i.e., devolve um valor positivo se o segundo for maior.*/
	INCREASING {

		@Override
		public int compare(Double o1, Double o2) {
			return o1.compareTo(o2);
		}
	},
	/**Ordem decrescente, i.e., devolve um valor positivo se o primeiro for maior.*/
	DECREASING {

		@Override
		public int compare(Double o1, Double o2) {
			return o2.compareTo(o1);
		}
	};
}
